{*******************************************************************************
 Project   : NoteIt
 Filename  : Not available
 Date      : 2002-10-27
 Version   : 2.3         Last modified: 2003-09-06
 Author    : Michael Puff
 URL       : www.luckie-online.de
 Copyright : Copyright (c) 2003 Michael Puff

           When I die I want 'Hello, world' carved on my headstone.

 Fenstergre/Hotkey modifiziert [Zeile 156 & 204] - 2003-10-01
 (Michael Gasperl, http://mgasperl.at.tf)

*******************************************************************************}

{*******************************************************************************

 Copyright (c) 2001-2003, Michael Puff ["copyright holder(s)"]
 All rights reserved.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are met:

 1. Redistributions of source code must retain the above copyright notice, this
    list of conditions and the following disclaimer.
 2. Redistributions in binary form must reproduce the above copyright notice,
    this list of conditions and the following disclaimer in the documentation
    and/or other materials provided with the distribution.
 3. The name(s) of the copyright holder(s) may not be used to endorse or
    promote products derived from this software without specific prior written
    permission.

 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY
 DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

*******************************************************************************}

program NoteIit_size_fullscr;

{$R main.res}

uses
  Windows,
  Messages,
  ShellAPI;

{$INCLUDE AppTools.pas}
{$INCLUDE FileTools.pas}

const
  WM_SHELLNOTIFY = WM_USER + 5;

const
  IDI_TRAY = 0;
  IDM_EXIT = 101;
  IDM_OPEN = 102;
  IDM_ABOUT = 103;

  ID_HK_OPEN = 104;

const
  ClassName = 'TrayIconWinClass';
  AppName = 'NoteIt';

  APPTITLE = 'NoteIt';
  VER = '2.3';

  INFO_TEXT = APPTITLE + ' ' + VER +#13#10 +
    'Copyright  2003 Michael Puff' + #13#10 + #13#10+
    'www.luckie-online.de';

const
  MAXSIZE = 260;
  MEMSIZE = 65535;
  FILENAME = 'NoteIt.txt';
  WM_RESETSELECTION = WM_USER + 1;

var
  hNoteIt: Cardinal;
  nid: TNotifyIconData;
  hPopupMenu, hEdit: Cardinal;
  IsOpened : Boolean = False;

var
  hFile, hMemory: Cardinal;
  pMemory: Pointer;
  SizeReadWrite: DWORD;

procedure OpenFile(hwndNoteIt: HWND; hWndEdit: THandle);
begin
  hFile := CreateFile(FILENAME, GENERIC_READ or GENERIC_WRITE,
    FILE_SHARE_READ or FILE_SHARE_WRITE, nil, OPEN_ALWAYS,
    FILE_ATTRIBUTE_ARCHIVE, 0);
  if hFile = INVALID_HANDLE_VALUE then
  begin
    RaiseLastError(hWndNoteIt);
    exit;
  end;
  hMemory := GlobalAlloc(GMEM_MOVEABLE or GMEM_ZEROINIT, MEMSIZE);
  if hMemory = 0 then
  begin
    RaiseLastError(hWndNoteIt);
    CloseHandle(hFile);
    exit;
  end;
  pMemory := GlobalLock(hMemory);
  ReadFile(hFile, pMemory^, MEMSIZE - 1, SizeReadWrite, nil);
  SendMessage(hwndEdit, WM_SETTEXT, 0, Integer(pMemory));
  CloseHandle(hFile);
  GlobalUnlock(DWORD(pMemory));
  GlobalFree(hMemory);
end;

procedure SaveFile(hwndNoteIt: HWND; hWndEdit: THandle);
begin
  hFile := CreateFile(FILENAME, GENERIC_READ or GENERIC_WRITE,
    FILE_SHARE_READ or FILE_SHARE_WRITE, nil, CREATE_ALWAYS,
    FILE_ATTRIBUTE_ARCHIVE, 0);
  if hFile = INVALID_HANDLE_VALUE then
  begin
    RaiseLastError(hWndNoteIt);
    exit;
  end;
  hMemory := GlobalAlloc(GMEM_MOVEABLE or GMEM_ZEROINIT, MEMSIZE);
  pMemory := GlobalLock(hMemory);
  SizeReadWrite := SendMessage(hWndEdit, WM_GETTEXT, MEMSIZE - 1,
    Integer(pMemory));
  WriteFile(hFile, pMemory^, SizeReadWrite, SizeReadWrite, nil);
  SendMessage(hWndEdit, EM_SETSEL, 0, 0);
  CloseHandle(hFile);
  GlobalUnlock(DWORD(pMemory));
  GlobalFree(hMemory);
  EndDialog(hWndNoteIt, 0);
end;

function DlgNoteItFunc(hDlg: Cardinal; iMsg: dword; wParam: wparam;
  lParam: lParam): bool; stdcall;
var
  x, y: Integer;
begin
  result := true;
  case iMsg of
    WM_INITDIALOG:
      begin
        x := GetSystemMetrics(SM_CXSCREEN);
        y := GetSystemMetrics(SM_CYSCREEN);
        SetWindowPos(hDlg, HWND_TOPMOST, x - 210, y - 410, 190, 380, SWP_NOACTIVATE);
        hEdit := GetDlgItem(hDlg, 103);
        SendMessage(hDlg, WM_SETICON, ICON_BIG, Integer(LoadIcon(HInstance,
          MakeIntResource(1))));
        OpenFile(hDlg, hEdit);
        PostMessage(hDlg, WM_RESETSELECTION, 0, 0);
      end;
    WM_RESETSELECTION: SendMessage(hEdit, EM_SETSEL, SIZEREADWRITE,
        SIZEREADWRITE);
    WM_SIZE: MoveWindow(GetDlgItem(hDlg, 103), 0, 0, loword(lParam), hiword(lParam), True);
    WM_CLOSE:
      begin
        SaveFile(hDlg, hEdit);
        IsOpened := False;
        Shell_NotifyIcon(NIM_ADD, @nid);
      end;
  else
    result := false;
  end;
end;

function WndProc(hWnd: HWND; uMsg: UINT; wParam: WPARAM; lParam: LPARAM):
  LRESULT; stdcall;
var
  pt: TPoint;
begin
  Result := 0;
  case uMsg of
    WM_CREATE:
      begin
        hNoteIt := hWnd;
        nid.cbSize := SizeOf(TNotifyIconData);
        nid.Wnd := hWnd;
        nid.uID := IDI_TRAY;
        nid.uFlags := NIF_ICON or NIF_MESSAGE or NIF_TIP;
        nid.uCallbackMessage := WM_SHELLNOTIFY;
        //only valid for Win9x
        nid.hIcon := GetClassLong(hWnd, GCL_HICONSM);
        if nid.hIcon = 0 then
          nid.hIcon := GetClassLong(hWnd, GCL_HICON);

        hPopupMenu := CreatePopupMenu;
        AppendMenu(hPopupMenu, MF_STRING, IDM_OPEN, 'ffnen' + #9 + 'Alt+F1');
        AppendMenu(hPopupMenu, MF_STRING, IDM_EXIT, 'Beenden');
        AppendMenu(hPopupMenu, MF_STRING, MF_SEPARATOR, nil);
        AppendMenu(hPopupMenu, MF_STRING, IDM_ABOUT, 'ber ...');
        SetMenuDefaultItem(hPopupMenu, IDM_OPEN, MF_BYCOMMAND);
        ShowWindow(hWnd, SW_MINIMIZE);
        RegisterHotkey(hwnd, ID_HK_OPEN, MOD_ALT, VK_F1);
      end;
    WM_DESTROY:
      begin
        DestroyMenu(hPopupMenu);
        PostQuitMessage(0);
      end;
    WM_SIZE:
      if wParam = SIZE_MINIMIZED then
      begin
        lstrcpy(nid.szTip, AppName);
        ShowWindow(hWnd, SW_HIDE);
        Shell_NotifyIcon(NIM_ADD, @nid);
      end;
    WM_HOTKEY:
      begin
        case wParam of
          ID_HK_OPEN:
            begin
              if not IsOpened then
              begin
                Shell_NotifyIcon(NIM_DELETE, @nid);
                IsOpened := True;
                DialogBoxParam(HInstance, MAKEINTRESOURCE(100), hWnd,
                  @DlgNoteItFunc, 0);
              end;
            end;
        end;
      end;
      WM_COMMAND:
      if lParam = 0 then
      begin
        case LoWord(wParam) of
          IDM_OPEN: DialogBoxParam(HInstance, MAKEINTRESOURCE(100), hWnd,
              @DlgNoteItFunc, 0);
          IDM_EXIT:
            begin
              UnregisterHotkey(hwnd, ID_HK_OPEN);
              Shell_NotifyIcon(NIM_DELETE, @nid);
              DestroyWindow(hWnd);
            end;
          IDM_ABOUT: MyMessagebox(hWnd, INFO_TEXT, 2);
        end;
      end;
    WM_SHELLNOTIFY:
      if wParam = IDI_TRAY then
      begin
        case lParam of
          WM_RBUTTONDOWN:
            begin
              GetCursorPos(pt);
              SetForegroundWindow(hWnd);
              TrackPopupMenu(hPopupMenu, TPM_RIGHTALIGN or TPM_RIGHTBUTTON,
                pt.x, pt.y, 0, hWnd, nil);
              PostMessage(hWnd, WM_NULL, 0, 0);
            end;
          WM_LBUTTONUP:
            begin
              Shell_NotifyIcon(NIM_DELETE, @nid);
              DialogBoxParam(HInstance, MAKEINTRESOURCE(100), hWnd,
                @DlgNoteItFunc, 0);
            end;
        end;
      end;
  else
    Result := DefWindowProc(hWnd, uMsg, wParam, lParam);
  end;
end;

var
  wc: TWndClassEx = (
    cbSize: SizeOf(TWndClassEx);
    style: CS_HREDRAW or CS_VREDRAW or CS_DBLCLKS;
    lpfnWndProc: @WndProc;
    cbClsExtra: 0;
    cbWndExtra: 0;
    hbrBackground: COLOR_APPWORKSPACE;
    lpszMenuName: nil;
    lpszClassName: ClassName;
    hIconSm: 0;
    );
  msg: TMsg;
  hMutex: Cardinal;

begin
  hMutex := CreateMutex(nil, TRUE, ClassName);
  if GetLasTError = ERROR_ALREADY_EXISTS then
  begin
    halt;
  end;
  wc.hInstance := HInstance;
  wc.hIcon := LoadIcon(hInstance, MAKEINTRESOURCE(1)); //Icon aus Res-Datei
  wc.hCursor := LoadCursor(hInstance, IDC_ARROW);
  RegisterClassEx(wc);
  CreateWindowEx(WS_EX_APPWINDOW or WS_EX_CLIENTEDGE, ClassName, AppName,
    0, Integer(CW_USEDEFAULT), Integer(CW_USEDEFAULT), 0, 0, 0, 0, HInstance,
    nil);
  while True do
  begin
    if not GetMessage(msg, 0, 0, 0) then
      Break;
    TranslateMessage(msg);
    DispatchMessage(msg);
  end;
  ReleaseMutex(hMutex);
  CloseHandle(hMutex);
  ExitCode := msg.wParam;
end.

